﻿using System;

namespace PayDemo
{
    public partial class Default : System.Web.UI.Page
    {

        protected void Page_Load(object sender, EventArgs e)
        {
            
        }

        protected void btnBuy_Click(object sender, EventArgs e)
        {
            AliPay(txtAmount.Text, txtProductName.Text, "这里是商品描述", txtTradeNo.Text);
        }

        protected void btnChinaBankPay_Click(object sender, EventArgs e)
        {
            ChinaBankPay(txtAmount.Text, txtTradeNo.Text);
        }

        /// <summary>
        /// 支付宝支付
        /// </summary>
        /// <param name="amount">商品总价</param>
        /// <param name="productName">商品名称</param>
        /// <param name="productDescription">商品描述</param>
        /// <param name="tradeOrderNo">商品的订单号</param>
        private void AliPay(string amount,string productName,string productDescription,string tradeOrderNo)
        {
            //为按顺序连接 总金额、 商户编号、订单号、商品名称、商户密钥的MD5值。
            string md5 = Common.SecurityHelper.GetMD5(amount + Consts.sellerId + tradeOrderNo + productName + Consts.sellerKey);
            //商户id + 回调地址 + 商品名称 + 商品
            string url = Consts.AliPayGateUrl+"?partner=" + Consts.sellerId + "&return_url=" + Server.UrlEncode("http://localhost:3282/Alipay/AliPayCallback.aspx") + "&subject=" + Server.UrlEncode(productName) + "&body="+ productDescription + "&out_trade_no=" + tradeOrderNo + "&total_fee=" + amount + "&seller_email=abc@abc.com&sign=" + md5;
            //重定向到支付平台
            Response.Redirect(url);
        }

        /// <summary>
        /// 网银在线支付
        /// </summary>
        /// <param name="amount">付款金额</param>
        /// <param name="tradeOrderNo">订单号</param>
        private void ChinaBankPay(string amount, string tradeOrderNo)
        {
            //按顺序连接  总金额、币种、订单号、商户编号、商户密钥为新字符串的MD5值。
            string md5 = Common.SecurityHelper.GetMD5(amount+"0" + tradeOrderNo +Consts.sellerId + Consts.sellerKey);
            //商户id + 回调地址 + 商品名称 + 商品
            string url = Consts.ChinaBankGateUrl + "?v_mid=" + Consts.sellerId + "&v_url=" + Server.UrlEncode("http://localhost:3282/ChinaBank/ChinaBankCallback.aspx") + "&v_moneytype=0&style=0&v_oid=" + tradeOrderNo + "&v_amount=" + amount + "&v_md5info=" + md5;
            //重定向到支付平台
            Response.Redirect(url);
        }
    }
}